Attribute VB_Name = "modWic"
' Autor: F. Schler
' Datum: 07/2020

Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Private Const CLSCTX_INPROC As Long = &H1&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&

Public Const CLSID_WICImagingFactory As String = "{cacaf262-9370-4615-a13b-9f5539da4c0a}"
Public Const CLSID_WICImagingFactory1 As String = CLSID_WICImagingFactory
Public Const CLSID_WICImagingFactory2 As String = "{317d06e8-5f24-433d-bdf7-79ce68d8abc2}"
Public Const IID_IWICImagingFactory As String = "{ec5ec8a9-c395-4314-9c77-54d7a935ff70}"

Public Const GUID_ContainerFormatBmp As String = "{0af1d87e-fcfe-4188-bdeb-a7906471cbe3}"
Public Const GUID_ContainerFormatPng As String = "{1b7cfaf4-713f-473c-bbcd-6137425faeaf}"
Public Const GUID_ContainerFormatIco As String = "{a3a860c4-338f-4c17-919a-fba4b5628f21}"
Public Const GUID_ContainerFormatJpeg As String = "{19e4a5aa-5662-4fc5-a0c0-1758028e1057}"
Public Const GUID_ContainerFormatTiff As String = "{163bcc30-e2e9-4f0b-961d-a3e9fdb788a3}"
Public Const GUID_ContainerFormatGif As String = "{1f8a5601-7d4d-4cbd-9c82-1bc8d4eeb9a5}"
Public Const GUID_ContainerFormatWmp As String = "{57a37caa-367a-4540-916b-f183c5093a4b}"

' zb fr BMP
Public Const GUID_WICPixelFormat24bppBGR As String = "{6fddc324-4e03-4bfe-b185-3d77768dc90c}"

' zb fr GIF
Public Const GUID_WICPixelFormat8bppIndexed As String = "{6fddc324-4e03-4bfe-b185-3d77768dc904}"

' zb fr DDS
Public Const GUID_WICPixelFormat32bppBGRA As String = "{6FDDC324-4E03-4BFE-B185-3D77768DC90F}"

' ----==== Enums ====----
Public Enum vtb_Interfaces
    
    ' IWICImagingFactory
    CreateDecoderFromFilename = 3
    CreateEncoder = 8
    CreateFormatConverter = 10
    CreateBitmapScaler = 11
    CreateBitmapFlipRotator = 13
    CreateStream = 14
    CreateBitmap = 17
    CreateBitmapFromSource = 18
        
    ' IWICBitmapDecoder
    GetFrameCount = 12
    GetFrame = 13
    
    ' IWICBitmapSource
    GetSize = 3
    GetPixelFormat = 4

    ' IWICBitmap
    LockBits = 8 ' Lock

    ' IWICBitmapLock
    GetDataPointer = 5

    ' IWICFormatConverter
    Initialize_FC = 8
    
    'IWICBitmapScaler
    Initialize_BS = 8
    
    ' IWICBitmapFlipRotator
    Initialize_BFR = 8
    
    ' IWICBitmapEncoder
    Initialize_BE = 3
    CreateNewFrame = 10
    Commit_BE = 11
    
    ' IWICBitmapFrameEncode
    Initialize_BFE = 3
    SetSize = 4
    SetPixelFormat = 6
    WriteSource = 11
    Commit_BFE = 12

    ' IWICStream
    InitializeFromFilename = 15
    
End Enum

Public Enum WICAccessOption
    GENERIC_READ = &H80000000
    GENERIC_WRITE = &H40000000
End Enum

Public Enum WICDecodeOptions
    WICDecodeMetadataCacheOnDemand = &H0&
    WICDecodeMetadataCacheOnLoad = &H1&
End Enum

Public Enum WICBitmapEncoderCacheOption
    WICBitmapEncoderCacheInMemory = &H0&
    WICBitmapEncoderCacheTempFile = &H1&
    WICBitmapEncoderNoCache = &H2&
End Enum

Public Enum WICBitmapCreateCacheOption
    WICBitmapNoCache = &H0&
    WICBitmapCacheOnDemand = &H1&
    WICBitmapCacheOnLoad = &H2&
End Enum

Public Enum WICBitmapDitherType
    WICBitmapDitherTypeNone = &H0&
    WICBitmapDitherTypeSolid = WICBitmapDitherTypeNone
    WICBitmapDitherTypeOrdered4x4 = &H1&
    WICBitmapDitherTypeOrdered8x8 = &H2&
    WICBitmapDitherTypeOrdered16x16 = &H3&
    WICBitmapDitherTypeSpiral4x4 = &H4&
    WICBitmapDitherTypeSpiral8x8 = &H5&
    WICBitmapDitherTypeDualSpiral4x4 = &H6&
    WICBitmapDitherTypeDualSpiral8x8 = &H7&
    WICBitmapDitherTypeErrorDiffusion = &H8&
End Enum

Public Enum WICBitmapPaletteType
    WICBitmapPaletteTypeCustom = &H0&
    WICBitmapPaletteTypeMedianCut = &H1&
    WICBitmapPaletteTypeFixedBW = &H2&
    WICBitmapPaletteTypeFixedHalftone8 = &H3&
    WICBitmapPaletteTypeFixedHalftone27 = &H4&
    WICBitmapPaletteTypeFixedHalftone64 = &H5&
    WICBitmapPaletteTypeFixedHalftone125 = &H6&
    WICBitmapPaletteTypeFixedHalftone216 = &H7&
    WICBitmapPaletteTypeFixedWebPalette = WICBitmapPaletteTypeFixedHalftone216
    WICBitmapPaletteTypeFixedHalftone252 = &H8&
    WICBitmapPaletteTypeFixedHalftone256 = &H9&
    WICBitmapPaletteTypeFixedGray4 = &HA&
    WICBitmapPaletteTypeFixedGray16 = &HB&
    WICBitmapPaletteTypeFixedGray256 = &HC&
End Enum

Public Enum WICBitmapInterpolationMode
    WICBitmapInterpolationModeNearestNeighbor = &H0&
    WICBitmapInterpolationModeLinear = &H1&
    WICBitmapInterpolationModeCubic = &H2&
    WICBitmapInterpolationModeFant = &H3&
End Enum

Public Enum WICBitmapTransformOptions
    WICBitmapTransformRotate0 = &H0&
    WICBitmapTransformRotate90 = &H1&
    WICBitmapTransformRotate180 = &H2&
    WICBitmapTransformRotate270 = &H3&
    WICBitmapTransformFlipHorizontal = &H8&
    WICBitmapTransformFlipVertical = &H10&
End Enum

Public Enum WICBitmapLockFlags
    WICBitmapLockRead = &H1&
    WICBitmapLockWrite = &H2&
End Enum

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type WICRect
    x As Long
    y As Long
    width As Long
    height As Long
End Type

' ----==== OleAut32 API-Deklarationen ====----
Private Declare Function DispCallFunc Lib "OleAut32.dll" ( _
                    ByVal pvInstance As Long, _
                    ByVal oVft As Long, _
                    ByVal cc As Long, _
                    ByVal vtReturn As VbVarType, _
                    ByVal cActuals As Long, _
                    ByVal prgvt As Any, _
                    ByVal prgpvarg As Any, _
                    ByRef pvargResult As Variant) As Long

' ----==== Kernel32 API-Deklarationen ====----
Public Declare Sub CopyMemory Lib "Kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef Destination As Any, _
                   ByRef Source As Any, _
                   ByVal Length As Long)

' ----==== Ole32 API-Deklarationen ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pclsid As GUID) As Long

Private Declare Function CoCreateInstance Lib "Ole32.dll" ( _
                         ByVal rclsid As Long, _
                         ByVal pUnkOuter As Long, _
                         ByVal dwClsContext As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long

' ----==== Create Interface ====----
Public Function CreateInterface(ByVal sCLSID As String, _
    ByVal sIID As String, ByRef pInterface As Long) As Boolean

    ' Interface erstellen
    If CoCreateInstance(VarPtr(Str2Guid(sCLSID)), 0&, CLSCTX_INPROC, _
        VarPtr(Str2Guid(sIID)), pInterface) = S_OK Then

        CreateInterface = True

    End If

End Function

' ----==== Release Interface ====----
Public Sub ReleaseInterface(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Public Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

Private Function OleInvoke(ByVal pInterface As Long, ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lCount As Long
    Dim lItem As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' ist ein Pointer auf ein Interface vorhanden
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

' ----==== Helper Function ====----
Public Function Str2Guid(ByVal sStr As String) As GUID

    If Len(sStr) > 0& Then

        Call CLSIDFromString(StrPtr(sStr), Str2Guid)
    
    End If
    
End Function

